#include <assert.h>
#include <math.h>

void out_normal(const double * p, const double ** v, int i, double * n)
{
  double area;
  int ip1, ip2, ip3;
  // 当前顶点排序方案中，0,2面是逆时针，1,3面是顺时针
  ip1 = (i+1)%4;
  if((i == 0) || (i == 2)){
    ip2 = (i+2)%4; ip3 = (i+3)%4;
  } else {
    ip2 = (i+3)%4; ip3 = (i+2)%4;
  }

  n[0] = ((v[ip2][1] - v[ip1][1])*(v[ip3][2] - v[ip1][2]) -
           (v[ip2][2] - v[ip1][2])*(v[ip3][1] - v[ip1][1]));
  n[1] = ((v[ip2][2] - v[ip1][2])*(v[ip3][0] - v[ip1][0]) -
          (v[ip2][0] - v[ip1][0])*(v[ip3][2] - v[ip1][2]));
  n[2] = ((v[ip2][0] - v[ip1][0])*(v[ip3][1] - v[ip1][1]) -
          (v[ip2][1] - v[ip1][1])*(v[ip3][0] - v[ip1][0]));
  area = sqrt(n[0]*n[0] + n[1]*n[1] + n[2]*n[2]);
  n[0] /= area;
  n[1] /= area;
  n[2] /= area;
}

/**
 * end of file
 * 
 */
